##
## jabberif config plugin
##	configuration parser
##	this is a core plugin and therefore should not be removed during runtime.
##
##
##	written by Ben Fuhrmannek <bef@erlangen.ccc.de>
##

from baseclasses import core_plugin
import sys,os
import ConfigParser		## config file parsing

class config_plugin(core_plugin):
	def __init__(self, ph):
		self.ph = ph
		self._name = 'config_plugin'
		self._desc = 'configuration parser'

		self.__config = {}

		self._filename = os.path.abspath(os.path.dirname(sys.argv[0]))+'/jabberif.conf'
		ph._register_function(self, 'read_config', self.read_config)
		ph._register_function(self, 'get_config', self.get_config)


	####################################################################################################
	## configuration functions -- accessible via the pluginhandler

	def read_config(self, filename=None):
		if not filename:
			filename = self._filename
		self._file = filename
		self.__config = {}

		config = ConfigParser.ConfigParser()
		config.set('DEFAULT', 'home', os.path.abspath(os.path.dirname(sys.argv[0])))
		config.read(filename)

		for section in config.sections():
			self.__config[section] = {}
			for name, value in config.items(section):
				self.__config[section][name] = value

	def get_config(self, section, default = {}):
		config = default
		if self.__config.has_key(section):
			for key in self.__config[section]:
				config[key] = self.__config[section][key]
		return config

		
