##
## jabberif leo plugin
##	lookup words in dict.leo.org
##
##	written by Ben Fuhrmannek <bef@erlangen.ccc.de>
##
##

from baseclasses import output_plugin
import urllib, re, string


class leo_plugin(output_plugin):
	def __init__(self, ph):
		## requierd variables
		self.ph = ph				## the pluginhandler instance
		self._name = 'leo_plugin'		## plugin name
		self._desc = 'search in dict.leo.org'	## short description
		
		self.__default_config = { 'http_proxy':None }
		self._configure()

	def _configure(self):
		self.__config = self.ph.get_plugin_config(self, self.__default_config)

	def _on_load(self):
		self.ph._register_command(self, 'dict', self.dict_query, '[word] translate via dict.leo.org')
		


	####################################################################################################
	## search functions
	
	##
	## found on http://www.inf.tu-dresden.de/python-kurs/PythonKurs/lehreinheiten/10-Urllib/trans_musterlsg.py
	##	and heavily modified by BeF
	##
	def __translate(self, word):

		def rm_html_tags(string):
			string = re.sub(r"</.*?>","",string)
			string = re.sub(r"<.*?>","",string)
			return string


		params = urllib.urlencode(
			{'search': word,
			 "searchLoc":"0",
			 "relink":"off",
			 "deStem":"standard",
			 "lang":"en"
			 }
			)

		proxy = None
		if self.__config['http_proxy']:
			proxy = {'http': 'http://'+self.__config['http_proxy']}
		content = urllib.urlopen("http://dict.leo.org/", params, proxy).read()
		#mo = re.search("search results.*?<TABLE.*?<TR>\s*.*?Direct Matches(.*?)(COLSPAN=5|</TR>)\s*?</TABLE>", content, re.DOTALL)
		mo = re.search("search results.*?<TABLE.*?<TR>\s*.*?COLSPAN=5(.*?)(COLSPAN=5|</TR>)\s*?</TABLE>", content, re.DOTALL)
		
		if not mo:
			return []

		section = mo.group(1)
		all = re.findall("43%.*?TD", section)
		return [(rm_html_tags(all[i][5:-4]), rm_html_tags(all[i+1][5:-4])) for i in range(0, len(all), 2)]
	
	####################################################################################################
	## command functions
		
	def dict_query(self, args):
		command_line_args = args['cmd'][1:]
		
		out = []
		for en,de in self.__translate(string.join(command_line_args, " ")):
			out.append(en + " <=> " + de)

		args['msg'].send_back(unicode('\n'+string.join(out, '\n'), 'iso8859-1'))

