##
## jabberif raw input plugin
##	provides jabberif i/o via stdio
##
##	written by Ben Fuhrmannek <bef@erlangen.ccc.de>
##

from baseclasses import input_plugin
from helpers import message

class raw_input_plugin(input_plugin):
	def __init__(self, ph):
		self.ph = ph
		self._name = 'raw_input_plugin'
		self._desc = 'stdio i/o'
		self.__prompt = "> "
		self._inputtype = 'raw'
		
	def process(self):
		try:
			in_msg = raw_input(self.__prompt)
			msg = message(self._inputtype, self, 'stdin', in_msg)
			self.ph._process_request(msg=msg, threaded=True, dos_detection=True)
		except EOFError: ## quit after EOF / Crtl-D
			self.ph._quit()
			
	
	def _send_back(self, msg, message):
		message = unicode(message).encode('latin-1', 'replace')
		print "reply:", message

	def _send(self, name, message):
		print "incoming message:", message
		return None
	
	def _is_available(self, id):
		return True
	
